import * as _udecode_plate_core from '@udecode/plate-core';
import { PluginConfig, EditorNodesOptions, NodeEntry, SetNodesOptions, OverrideEditor, TNode } from '@udecode/plate';
import { T as TCommentText } from './types-B9ejEHWF.mjs';

type BaseCommentsConfig = PluginConfig<'comment', {}, {
    comment: {
        has: (options: {
            id: string;
        }) => boolean;
        node: (options?: EditorNodesOptions & {
            id?: string;
            isDraft?: boolean;
        }) => NodeEntry<TCommentText> | undefined;
        nodeId: (leaf: TCommentText) => string | undefined;
        nodes: (options?: EditorNodesOptions & {
            id?: string;
            isDraft?: boolean;
        }) => NodeEntry<TCommentText>[];
    };
}, {
    comment: {
        removeMark: () => void;
        setDraft: (options?: SetNodesOptions) => void;
        unsetMark: (options: {
            id: string;
        }) => void;
    };
}>;
declare const BaseCommentsPlugin: _udecode_plate_core.SlatePlugin<PluginConfig<"comment", {}, {
    comment: {
        has: (options: {
            id: string;
        }) => boolean;
        node: (options?: EditorNodesOptions & {
            id?: string;
            isDraft?: boolean;
        }) => NodeEntry<TCommentText> | undefined;
        nodeId: (leaf: TCommentText) => string | undefined;
        nodes: (options?: EditorNodesOptions & {
            id?: string;
            isDraft?: boolean;
        }) => NodeEntry<TCommentText>[];
    };
} & Record<"comment", {
    has: (options: {
        id: string;
    }) => boolean;
    node: (options?: EditorNodesOptions & {
        id?: string;
        isDraft?: boolean;
    }) => NodeEntry<TCommentText> | undefined;
    nodeId: (leaf: TCommentText) => string | undefined;
    nodes: (options?: EditorNodesOptions & {
        id?: string;
        isDraft?: boolean;
    }) => NodeEntry<TCommentText>[];
}>, {
    comment: {
        removeMark: () => void;
        setDraft: (options?: SetNodesOptions) => void;
        unsetMark: (options: {
            id: string;
        }) => void;
    };
} & Record<"comment", {
    removeMark: () => void;
    setDraft: (options?: SetNodesOptions) => void;
    unsetMark: (options: {
        id: string;
    }) => void;
}>, {}>>;

declare const withComments: OverrideEditor<BaseCommentsConfig>;

declare const getCommentCount: (node: TCommentText) => number;

declare const getCommentKey: (id: string) => string;

declare const getCommentKeyId: (key: string) => string;

declare const getCommentKeys: (node: TCommentText) => string[];

declare const getDraftCommentKey: () => string;

declare const isCommentKey: (key: string) => boolean;

/** Whether the node has a comment id. */
declare const isCommentNodeById: (node: TNode, id: string) => boolean;

declare const isCommentText: (node: TNode) => node is TCommentText;

export { type BaseCommentsConfig, BaseCommentsPlugin, TCommentText, getCommentCount, getCommentKey, getCommentKeyId, getCommentKeys, getDraftCommentKey, isCommentKey, isCommentNodeById, isCommentText, withComments };
